local testimtopic = ""
local proseccolor = SKINCOLOR_NONE
local prosec
local defensecolor = SKINCOLOR_NONE
local defense
local textpos = 0

local function P_FindPlayerByNode(node)
	for p in players.iterate
		if #p == node then
			return p
		end
	end
end

COM_AddCommand("crossexamine", function(p, pro, topic, def)
	if not p.mo then
		CONS_Printf(p, "You can only do this in gameplay.")
		return
	end
	
	if testimonyprogress then
		rawset(_G, "testimonyprogress", 0)
	end
	
	if tonumber(pro) == nil then
		CONS_Printf(p, "You need to specify a prosecutor player node.")
		return
	end
	
	if topic then
		testimtopic = topic
	else
		testimtopic = "Witness's Account"
	end
	prosec = P_FindPlayerByNode(tonumber(pro))
	proseccolor = prosec.mo.color
	if def then
		defense = P_FindPlayerByNode(tonumber(def))
	else
		defense = p
	end
	defensecolor = defense.mo.color
	rawset(_G, "examinationprogress", 1)
	chatprint("\x82* Commencing Cross-Examination...")
	chatprint("\x82*\x80 Testimony topic: \x87"..testimtopic)
	S_StartSound(nil, sfx_aaxmnt)
end)

addHook("MapLoad", do
	rawset(_G, "examinationprogress", 0)
end)

addHook("PlayerThink", function(p)
	if not p.mo then return end
	
	if examinationprogress == 12 then
		P_FlashPal(p, PAL_WHITE, TICRATE/4)
	end
end)

hud.add(function(v, p, c)
	if not examinationprogress then return end
	
	if examinationprogress == 3*TICRATE then
		S_StartSound(nil, sfx_aatrns, p)
	end
	
	if examinationprogress >= 3*TICRATE and examinationprogress <= 7*TICRATE/2 then
		textpos = $+19
	elseif examinationprogress < 12
		textpos = -320+examinationprogress*27
	else
		textpos = 0
	end
	
	if examinationprogress <= 7*TICRATE/2 then
		v.draw(textpos, 0, v.cachePatch("AACROSS"))
		v.draw(-textpos, 0, v.cachePatch("AAXMNTN"))
		if examinationprogress >= 12 then
			v.draw(-textpos, 10, v.cachePatch("SUSPBACK"))
			v.draw(textpos, 10, v.cachePatch("SUSDBACK"))
			v.draw(-textpos, 10, v.getSprite2Patch(defense.mo.skin, "SUSP"), 0, v.getColormap(defense.mo.skin, defensecolor))
			v.draw(textpos, 10, v.getSprite2Patch(prosec.mo.skin, "SUSD"), 0, v.getColormap(prosec.mo.skin, proseccolor))
		end
	elseif examinationprogress <= 7*TICRATE/2+3*TICRATE then
		v.drawString(160, 100, "== "..testimtopic.." ==", V_ORANGEMAP, "thin-center")
	end
	
	if examinationprogress <= 7*TICRATE/2+3*TICRATE then
		rawset(_G, "examinationprogress", examinationprogress+1)
	end
end, "game")